var jwpc_global_var = null;
var jwpc_global_obj = [];
dojo.provide("jwpc.jwpc");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo._base.event");
dojo.require("dijit.dijit");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.DropDownButton");
dojo.require("dijit.Toolbar");
dojo.require("dijit.TooltipDialog");
dojo.require("dojo.string");
dojo.require("dojo.parser");
dojo.require("dijit.form.HorizontalSlider");
dojo.require("dojo.NodeList-manipulate");
dojo.require("dojox.embed.Flash");
dojo.require("dojo.NodeList-fx");

dojo.declare(
	"jwpc.jwpc",
	[dijit._Widget,dijit._Templated],
	{
		jwpc_videofile:"",
    jwpc_videolength:"",
		jwpc_previewimage:"",
		jwpc_videoheight:240,
		jwpc_videowidth:320,
		jwpc_captionfile:"",
		jwpc_captionstate:"false",
		jwpc_captionbg:"false",
    jwpc_captionfontsize:15,
		jwpc_audiodescfile:"", 
		jwpc_audiodescstate:"false",
		jwpc_advolume:80,
		jwpc_currentvolume:80,
		jwpc_volumeincrease:20,
		jwpc_volumedecrease:-20,
		jwpc_dockicons:"false",
		jwpc_icons:"false",
		jwpc_seekdivisor:20,
		jwpc_mute:"false",
		jwpc_token:"",
    jwpc_provider:"",
    jwpc_videotitle:"", 
    jwpc_plugins:"",
    jwpc_id:"",
		jwpc_flashVersion:"10.0",
		jwpc_expressInstall:false,
		jwpc_allowScriptAccess:"always",
		jwpc_focusable:"a,input,button,textarea,select,area,object,embed,[tabindex=0]",
    jwpc_headinglevel:"3",
 
	  maxHeight:null,
    maxWidth:null,
    vidHeight:null,
    vidWidth:null,
    newHeight:null,
    newWidth:null,
    ecB:null,
    eb:null,
    plw:null,
    plc:null,
   
    calcpos               :0,
    sliderIncrement       :0,
    valuenow              :0,
    forwardSkiptime       :0,
    backSkiptime          :0,
    jwpc_currentPosition  :0,
    jwpc_currentPlayState :null,
    jwpc_muteState        :false,
    jwpc_duration         :0,
    jwpc_player           :null,
    jwpc_oldPosition      :0,
    jwpc_timerfocus       :false,
    jwpc_arrowSeek        :false,
    duration              :0,
		tabindex              :[],
		templateString:"<div aria-describedby=\"${id}_jwpc_playerdesc\" aria-labelledby=\"${id}_jwpc_playerheader\"><div class=\"jwpc_playercontainer\" id=\"${id}_jwpc_playercontainer\" dojoAttachPoint=\"jwpc_playercontainer\"><h${jwpc_headinglevel} id=\"${id}_jwpc_playerheader\" tabindex=\"0\" class=\"jwpc_semantic\">Video: ${jwpc_videotitle}</h${jwpc_headinglevel}><div id=\"${id}_jwpc_playerdesc\" class=\"jwpc_semantic\"><p id=\"${id}_jwpc_instructions\">Tab to the Play/Pause button. Arrow keys navigate tool bar controls. Tab again for elapsed time and time scrubber slider.<br>Note: Scrubber does not work with VoiceOver on Mac.</p><p>Keyboard shortcuts work when the tool bar area is focused.</p><ul><li>Alt Control P to play and pause.</li><li>Alt Control S to stop.</li><li>Alt Control F to jump forward.</li><li>Alt Control B to jump back.</li><li>Alt Control D to decrease volume.</li><li>Alt Control U to increase volume.</li><li>Alt Control M to mute.</li><li>Alt Control A for audio descriptions.</li><li>Alt Control C for captions.</li><li>Alt Control R resizes the player.</li></ul><p>Note: Keyboard shortcuts do not work with VoiceOver on Mac.</p></div><div id=\"${id}_jwpc_playerwrapper\" role=\"application\" class=\"jwpc_playerwrapper\" dojoAttachPoint=\"jwpc_playerwrapper\"><div class=\"jwpc_playercontrols\" dojoAttachPoint=\"jwpc_playercontrols\"><div class=\"jwpc_playertoolbar\" dojoAttachPoint=\"jwpc_playertoolbar\"></div><div class=\"jwpc_timewrapper\" dojoAttachPoint=\"jwpc_timewrapper\"><div tabindex=\"0\" class=\"jwpc_timer\" aria-live=\"off\" aria-labelledby=\"${id}_jwpc_timerlabel\" dojoAttachPoint=\"jwpc_timer\"><span class=\"jwpc_timerlabel\" id=\"${id}_jwpc_timerlabel\" dojoAttachPoint=\"jwpc_timerlabel\">0:00:00/0:00:00</span></div><div class=\"jwpc_timeline\" id=\"${id}_jwpc_timeline\" dojoAttachPoint=\"jwpc_timeline\"></div></div></div><div class=\"jwpc_playerplaceholder\" id=\"${id}_jwpc_playerplaceholder\" dojoAttachPoint=\"jwpc_playerplaceholder\"><div class=\"no-flash\"><p class=\"jwpc_semantic\">You will need the <a href=\"http://www.adobe.com/go/getflashplayer\">Flash Player</a> to see the video.</p></div></div></div></div>",
		
		baseClass:"jwpc",
    
    constructor:function()
    {
      jwpc_global_var = this;    
    },
    
		postCreate:function(){
 
			this.inherited(arguments);
      
      // Insert player progmatically
      if (this.jwpc_id != "") {
        dojo.byId(this.jwpc_id).appendChild(this.domNode);
      }; 
      
      // convert movie length
      var jw_tempmovlength = this.jwpc_videolength;
      jw_tempmovlength = dojo.trim(jw_tempmovlength);
      jw_tempmovlength.match(/(\d):(\d\d):(\d\d)/);
      var my_hours = RegExp.$1;
      var my_minutes = RegExp.$2;
      var my_seconds = RegExp.$3;
      this.jwpc_duration = (eval(my_hours*60*60)+eval(my_minutes*60)+eval(my_seconds));

      this.duration        = 100/this.jwpc_duration;
      this.jwpc_player     = this.id+"_movie";
      this.forwardSkiptime = Math.floor(this.jwpc_duration / this.jwpc_seekdivisor);
      this.backSkiptime    = Math.floor(this.jwpc_duration / this.jwpc_seekdivisor); 
      this.jwpc_videoheight += 24; // compensate for toolbar
      
      // human readable skiptimes
      var fsSec = Math.floor(this.forwardSkiptime%60);
      fsSec = dojo.string.pad(fsSec,2,"0");
      var fsMin = Math.floor((this.forwardSkiptime/60)%60);
      var fsHour = Math.floor(this.forwardSkiptime/(60*60));
      if (fsMin > 9 || fsHour > 0)
      {
        fsMin = dojo.string.pad(fsMin,2,"0");
      }
      this.skiptimeHuman="";
      if (fsHour > 0)
      { 
        this.skiptimeHuman = fsHour + " hours ";
      }
      if (eval(fsMin) > 0)
      {
        this.skiptimeHuman += fsMin + " minutes ";
      }
      this.skiptimeHuman += fsSec + " seconds";
 
      // establish sub headings in description section
      var subhead = parseInt(this.jwpc_headinglevel) + 1;
      dojo.place("<h"+ subhead +">Instructions</h"+ subhead +">",this.id+"_jwpc_playerdesc","first");
      dojo.place("<h"+ subhead +">Keyboard Shortcuts</h"+ subhead +">",this.id+"_jwpc_instructions","after");

      jwpc_global_obj.push(jwpc_global_var);
    
      // changed controlbar to none to fix safari problems (huh?, now set to bottom again...)
      var flashvars =
      {
        "file": this.jwpc_videofile,
        "image": this.jwpc_previewimage,
        "audiodescription.file" : this.jwpc_audiodescfile,
        "audiodescription.volume": this.jwpc_advolume,
        "audiodescription.state": this.jwpc_audiodescstate,
        "captions.file": this.jwpc_captionfile,
        "captions.back": this.jwpc_captionbg,
        "captions.fontsize": this.jwpc_captionfontsize,
        "captions.state": this.jwpc_captionstate,
        "controlbar": "bottom",
        "dock": this.jwpc_dockicons,
        "icons": this.jwpc_icons,
        "mute": this.jwpc_mute,
        "volume": this.jwpc_currentvolume,
        "id": this.jwpc_player,
        "provider":this.jwpc_provider,
        "token": this.jwpc_token
      };
      
      if (this.jwpc_audiodescfile != "")
      {
        flashvars.plugins = this.jwpc_plugins+"/audiodescription.swf";
      }
      if (this.jwpc_captionfile != "")
      {
        flashvars.plugins = this.jwpc_plugins+"/captions.swf";
      }
      if (this.jwpc_audiodescfile != "" && this.jwpc_captionfile != "")
      {
        flashvars.plugins = this.jwpc_plugins+"/audiodescription.swf"+","+this.jwpc_plugins+"/captions.swf";
      }
      
      var params =
      {
        "allowfullscreen": "true",
        "wmode": "opaque",
        "allowScriptAccess": "always",
        "allowNetworking": "all"
      };
      
      this.movie = new dojox.embed.Flash({
        expressInstall: this.jwpc_expressInstall,
        allowScriptAccess: this.jwpc_allowScriptAccess,
        params: params,       
        path: this.jwpc_plugins+"/player.swf",
        width: "100%",
        height: "100%",
        minimumVersion: this.jwpc_flashVersion,
        vars: flashvars,
        id: this.jwpc_player
      }, this.jwpc_playerplaceholder);  
      
      this.slider = new dijit.form.HorizontalSlider({
        value:0,
        name:this.id,
        onFocus: dojo.hitch(this, this.sliderFocus),
        onBlur: dojo.hitch(this, this.sliderBlur),
        onKeyUp: dojo.hitch(this, this.sliderKeyUp),
        onChange: dojo.hitch(this, this.sliderChange),
        onMouseEnter: dojo.hitch(this, this.sliderEnter),
        onMouseLeave: dojo.hitch(this, this.sliderLeave),
        onMouseUp: dojo.hitch(this, this.sliderMouseUp),
        intermediateChanges:"true",
        minimum:0,
        maximum:this.jwpc_duration,
        discreteValues:this.jwpc_duration + 1,
        showButtons:false
      },dojo.byId(this.id+"_jwpc_timeline"));
      
      if(dojox.embed.Flash.available < this.jwpc_flashVersion)
      { 
        dojo.query("#"+this.id+"_jwpc_playerplaceholder p").removeClass("jwpc_semantic");
      }
      else
      {
      
        var fullscreen = dojo.create("div", {id:this.id+"_fullscreen", innerHTML: '<div></div><p style="position: absolute; top: 41.5%; text-align: center; width: 100%; color: rgb(255, 255, 255);"><span id="fullscreen">To enable true fullscreen, right click in the video area<br />and click <strong>"Toggle&nbsp;Fullscreen..."</strong> from the menu.</span><span id="loading"><strong style="display:block;clear:both;margin-bottom:1em;">Loading...</strong><img src="jwpc/themes/base/images/loading.gif" width="128" height="15" alt="" /></span></p>' },this.jwpc_playerwrapper);  
        
        dojo.style(fullscreen, {
          "width": "100%", 
          "top": "0",
          "position": "absolute",
          "height": (this.jwpc_videoheight - 24) + "px",
          "text-align": "center",
          "fontSize":"1.1em",
          "left":"-9999px",
					"zIndex":"999"
        });      
        
        dojo.query("#"+this.id+"_fullscreen div").style({
          "width": "100%", 
          "height": "100%",
          "background": "rgb(0,0,0)",
          "opacity":"0"
        });        
        
        dojo.connect(fullscreen, "onmouseover", this, function() {
          if(this.jwpc_currentPlayState == "BUFFERING") 
          {
            dojo.query('#'+this.id+'_fullscreen #fullscreen').style({
              "display":"none"
            });
            dojo.query('#'+this.id+'_fullscreen #loading').style({
              "display":"block"
            });       
          }
		      else 
		      {
						dojo.query('#'+this.id+'_fullscreen div').fadeOut().play();						
		        dojo.query('#'+this.id+'_fullscreen p').fadeOut().play();
						dojo.style(this.id+'_fullscreen',{
							"left":-9999+"px"
						});
		      }
        });
        
        dojo.query(".jwpc_timer").onfocus(function(){
          dojo.addClass(this, "focused");
        });
        dojo.query(".jwpc_timer").onblur(function(){
          dojo.removeClass(this, "focused");
        });
      }
      
      dojo.style(this.jwpc_playercontainer, {width:this.jwpc_videowidth+"px"});
      dojo.style(this.jwpc_playerwrapper, {width:this.jwpc_videowidth+"px", height:this.jwpc_videoheight+"px"});
      
      this.toolbar = new dijit.Toolbar({}, this.jwpc_playertoolbar);
      
      this.playB = new dijit.form.Button({
        iconClass:"jwIcon jwIconPlay",
        showLabel:false,
        id:this.id+"_jwpc_Play",
        label:"Play/Pause",
        onClick:dojo.hitch(this, this.playPause)
      });
			this.stopB = new dijit.form.Button({
				iconClass:"jwIcon jwIconStop",
				showLabel:false,
				label:"Stop",
        onClick:dojo.hitch(this, this.stop)
			});
			this.backB = new dijit.form.Button({
				iconClass:"jwIcon jwIconBack",
				showLabel:false,
				label:"Jump Back "+this.skiptimeHuman,
        onClick:dojo.hitch(this, this.seekBack)
			});
			this.forwardB = new dijit.form.Button({
				iconClass:"jwIcon jwIconForward",
				showLabel:false,
				label:"Jump Forward "+this.skiptimeHuman,
        onClick:dojo.hitch(this, this.seekForward)
			});
			this.vdB = new dijit.form.Button({
				iconClass: "jwIcon jwIconVolumeDown",
				showLabel:false,
				id: this.id+"_jwpc_VolumeDown",
				label:"Decrease Volume to "+eval(this.jwpc_currentvolume + this.jwpc_volumedecrease)+"%",
        onClick:dojo.hitch(this, this.volumeDown)
			});
			this.vuB = new dijit.form.Button({
				iconClass: "jwIcon jwIconVolumeUp",
				showLabel:false,
				id: this.id+"_jwpc_VolumeUp",
				label:"Increase Volume to "+eval(this.jwpc_currentvolume + this.jwpc_volumeincrease)+"%",
        onClick:dojo.hitch(this, this.volumeUp)
			});
			this.muteB = new dijit.form.Button({
				iconClass: "jwIcon jwIconMuteOff",
				showLabel:false,
				id: this.id+"_jwpc_Mute",
				label:"Mute",
        onClick:dojo.hitch(this, this.mute)
			});   
      this.descriptionB = new dijit.form.Button({
        iconClass: "jwIcon jwIconAdOn",
        showLabel:false,
        id: this.id+"_jwpc_Description",
        label:"Audio Descriptions",
        onClick:dojo.hitch(this, this.description)
      });   
      this.captionsB = new dijit.form.Button({
        iconClass: "jwIcon jwIconCcOn",
        showLabel:false,
        id:this.id+"_jwpc_Captions",
        label:"Player Captions",
        onClick:dojo.hitch(this, this.captions)
      });  
      this.enlargeB = new dijit.form.Button({
        iconClass: "jwIcon jwIconEnlarge",
        showLabel:false,
        id: this.id+"_jwpc_Enlarge",
        label:"Enlarge Movie",
        onClick:dojo.hitch(this, this.enlarge),
        onMouseOver:dojo.hitch(this, this.enlargeMouseOver),
				onFocus:dojo.hitch(this, this.enlargeMouseOver),
        onMouseOut:dojo.hitch(this, this.enlargeMouseOut),
        onBlur:dojo.hitch(this, this.enlargeMouseOut)
      });
     
      this.slider.startup();
      this.toolbar.addChild(this.playB);
      this.toolbar.addChild(this.stopB);
      this.toolbar.addChild(this.backB);
      this.toolbar.addChild(this.forwardB);
      this.toolbar.addChild(new dijit.ToolbarSeparator());
      this.toolbar.addChild(this.vdB);
      this.toolbar.addChild(this.vuB);
      this.toolbar.addChild(this.muteB);
      this.toolbar.addChild(new dijit.ToolbarSeparator());
      
      if (this.jwpc_audiodescfile != "")
      {
        this.toolbar.addChild(this.descriptionB);
      }
      if (this.jwpc_captionfile != "")
      {
        this.toolbar.addChild(this.captionsB);
      }
      if (this.jwpc_audiodescfile != "" || this.jwpc_captionfile != "")
      {
        this.toolbar.addChild(new dijit.ToolbarSeparator());
      }
      this.toolbar.addChild(this.enlargeB);
      
      dojo.query("#"+this.id+" .dijitSliderImageHandle").html('<div id="'+this.id+'_jwpc_currentposition" class="jwpc_currentposition jwpc_semantic"><div><span class="jwpc_semantic">Current time: 0:00:00</span></div></div>');

      var mutB = dijit.byId(this.id+"_jwpc_Mute");
      var mute  = dojo.byId(this.id+"_jwpc_Mute").childNodes[0];
      
      if (this.jwpc_mute == "true")
      {
        mutB.set("label","Un-mute");
        dojo.removeClass(mute,"jwIconMuteOff");
        dojo.addClass(mute,"jwIconMuteOn");
      }
      else
      {
        mutB.set("label","Mute");
        dojo.removeClass(mute,"jwIconMuteOn");
        dojo.addClass(mute,"jwIconMuteOff");
      }      
      
      if (this.jwpc_audiodescfile != "")
      {
        var desc  = dojo.byId(this.id+"_jwpc_Description").childNodes[0];
        var descB = dijit.byId(this.id+"_jwpc_Description"); 
        
        if (this.jwpc_audiodescstate == "false") 
        {   
          dojo.removeClass(desc, "jwIconAdOn");
          dojo.addClass(desc, "jwIconAdOff");
          descB.set("label","Turn Audio Descriptions On");
        }      
        else
        {
          dojo.removeClass(desc, "jwIconAdOff");
          dojo.addClass(desc, "jwIconAdOn");
          descB.set("label","Turn Audio Descriptions Off");      
        }
      }

      if (this.jwpc_captionfile != "")
      {
        var cap  = dojo.byId(this.id+"_jwpc_Captions").childNodes[0];
        var capB = dijit.byId(this.id+"_jwpc_Captions");
        
        if (this.jwpc_captionstate == "false") 
        {   
          dojo.removeClass(cap, "jwIconCcOn");
          dojo.addClass(cap, "jwIconCcOff");
          capB.set("label","Turn Player Captions On");  
        } 
        else
        {
          dojo.removeClass(cap, "jwIconCcOff");
          dojo.addClass(cap, "jwIconCcOn");
          capB.set("label","Turn Player Captions Off");      
        }
      }

			dojo.connect(window, "onresize", this, this.windowReposition);
      dojo.connect(window, "onscroll", this, this.windowReposition);
    
      dojo.connect(dojo.byId(this.id), "onkeypress", this, function(event) {   
        if(event.altKey && event.keyChar == 'p' && (event.ctrlKey || event.metaKey))
        {
          dojo.byId(this.id+"_jwpc_Play").focus();
          this.playPause();
        }
        if(event.altKey && event.keyChar == 's' && (event.ctrlKey || event.metaKey))
        {
          this.stop();
        }
        if(event.altKey && event.keyChar == 'b' && (event.ctrlKey || event.metaKey))
        {
          this.seekBack();
        }
        if(event.altKey && event.keyChar == 'f' && (event.ctrlKey || event.metaKey))
        {
          this.seekForward();
        }
        if(event.altKey && event.keyChar == 'd' && (event.ctrlKey || event.metaKey))
        {
          this.volumeDown();
        }
        if(event.altKey && event.keyChar == 'u' && (event.ctrlKey || event.metaKey))
        {
          this.volumeUp();
        }
        if(event.altKey && event.keyChar == 'm' && (event.ctrlKey || event.metaKey))
        {
          this.mute();
        }
        if(event.altKey && event.keyChar == 'r' && (event.ctrlKey || event.metaKey))
        {
          this.enlarge();
        }
        /* only if already enlarged do we let ESC call it */
        if (event.keyCode == '27' && dojo.hasClass(this.id+"_jwpc_Enlarge","active") && dojox.embed.Flash.available >= this.jwpc_flashVersion)
        {
          this.enlarge();
        }         
        if (this.jwpc_captionfile != "")
        {
          if(event.altKey && event.keyChar == 'c' && (event.ctrlKey || event.metaKey))
          {
            this.captions();
          }
        }
        if (this.jwpc_audiodescfile != "")
        {
          if(event.altKey && event.keyChar == 'a' && (event.ctrlKey || event.metaKey))
          {
            this.description();
          }
        }
      });
      this.helpB = new dijit.form.DropDownButton({
        iconClass: "jwIcon jwIconHelp",
        showLabel:false,
        id:this.id+"_jwpc_Help",
        label:"Help"
      }); 
      this.toolbar.addChild(this.helpB);
      this.helpB.dropDown = new dijit.TooltipDialog({
        baseClass: "jwpc",
        style: "width: 385px",
        content: "<div class=\"jwpc_helpdialog\" role=\"document\" tabindex=\"0\"><h4>Keyboard Shortcuts Help</h4><p class=\"jwpc_semantic\">Escape to exit this dialog and return to tool bar controls.</p><p>Keyboard shortcuts are available when the player is focused.<br>Shortcuts do not work when video is full screen.</p><ul><li><code>Alt + Control + P</code> Toggle play and pause</li><li><code>Alt + Control + S</code> Stop</li><li><code>Alt + Control + F</code> Jump forward</li><li><code>Alt + Control + B</code> Jump back</li><li><code>Alt + Control + D</code> Decrease volume</li><li><code>Alt + Control + U</code> Increase volume</li><li><code>Alt + Control + M</code> Toggle sound mute</li><li><code>Alt + Control + A</code> Toggle audio descriptions (if available)</li><li><code>Alt + Control + C</code> Toggle captions (if available)</li><li><code>Alt + Control + R</code> Toggle resizing of player</li></ul></div>"
      });

			dojo.style(this.id,{
				width:dojo.marginBox(this.id+"_jwpc_playercontainer").w + "px",
				height:dojo.marginBox(this.id+"_jwpc_playercontainer").h + "px"
			});
			
			if(dojo.byId("jwpc-underlay-container") === null || dojo.byId("jwpc-underlay-container") === undefined) {
				dojo.create("div", { 
					id:"jwpc-underlay-container",
					innerHTML: "<div id=\"jwpc-shim\"></div>" 
				}, dojo.body());
			}

			if (dojo.isIE <= 7) {
				dojo.create("div",{
					id:this.id+"_ie-shim",
					style:"display:none"
				},this.id,"after");
			}

    }, 
		windowReposition:function() {
			if (dojo.hasClass(this.id+"_jwpc_Enlarge","active")) { 
        var viewport = dojo.window.getBox();
				dojo.style("jwpc-underlay-container", {
				  width: viewport.w + "px",
				  height: viewport.h + "px",
          top: viewport.t + "px",
          left: viewport.l + "px"
				});
				//TODO: re-position player vertically and horizontally and resize player(?)
			}
		},
    accessibilityButtonStateChecker: function() {
      var desc  = dojo.byId(this.id+"_jwpc_Description").childNodes[0];
      var descB = dijit.byId(this.id+"_jwpc_Description"); 

      var cap  = dojo.byId(this.id+"_jwpc_Captions").childNodes[0];
      var capB = dijit.byId(this.id+"_jwpc_Captions");  
        
      if (dojo.byId(this.jwpc_player).adState('') === 'false') 
      {   
        dojo.removeClass(desc, "jwIconAdOn");
        dojo.addClass(desc, "jwIconAdOff");
        descB.set("label","Turn Audio Descriptions On");
      }      
      else
      {
        dojo.removeClass(desc, "jwIconAdOff");
        dojo.addClass(desc, "jwIconAdOn");
        descB.set("label","Turn Audio Descriptions Off");      
      }
      
      if (dojo.byId(this.jwpc_player).captionState('') === 'false') 
      {   
        dojo.removeClass(cap, "jwIconCcOn");
        dojo.addClass(cap, "jwIconCcOff");
        capB.set("label","Turn Player Captions On");  
      } 
      else
      {
        dojo.removeClass(cap, "jwIconCcOff");
        dojo.addClass(cap, "jwIconCcOn");
        capB.set("label","Turn Player Captions Off");      
      }
    },
    enlargeMouseOver: function() {
			if(dojox.embed.Flash.available >= this.jwpc_flashVersion) {
	      dojo.query('#'+this.id+'_fullscreen #fullscreen').style({
	        "display":"block"
	      });
	      dojo.query('#'+this.id+'_fullscreen #loading').style({
	        "display":"none"
	      });     
	      dojo.style(this.id+'_fullscreen',{
	        "left":"0"
	      });
	      dojo.query('#'+this.id+'_fullscreen div').fadeIn({
	        end: 0.75
	      }).play();
	      dojo.query('#'+this.id+'_fullscreen p').fadeIn().play();
			}
    },
    enlargeMouseOut: function(e) {
    	if(dojox.embed.Flash.available >= this.jwpc_flashVersion) {
				if(this.jwpc_currentPlayState == "BUFFERING") 
	      {
	        dojo.query('#'+this.id+'_fullscreen #fullscreen').style({
	          "display":"none"
	        });
	        dojo.query('#'+this.id+'_fullscreen #loading').style({
	          "display":"block"
	        });       
	      }
	      else 
	      {
					dojo.query('#'+this.id+'_fullscreen div').fadeOut().play();						
	        dojo.query('#'+this.id+'_fullscreen p').fadeOut().play();
	      }
			}
    },
    sliderEnter: function() {
      dojo.addClass(this.id+"_jwpc_currentposition","hoverActive");
      dojo.removeClass(this.id+"_jwpc_currentposition","jwpc_semantic");
    },
    sliderLeave: function() {
      dojo.removeClass(this.id+"_jwpc_currentposition","hoverActive");
      
      if (!dojo.hasClass(this.id+"_jwpc_currentposition","focusActive"))
      {
        dojo.addClass(this.id+"_jwpc_currentposition","jwpc_semantic");
      }
    },
    sliderFocus: function() {
      if (this.jwpc_currentPosition == 0)
      {
        dijit.byId(this.id+"_jwpc_timeline").set('disabled',true);
      }
      if (this.jwpc_currentPlayState == "BUFFERING" || this.jwpc_currentPlayState == "PLAYING")
      {
        dojo.byId(this.jwpc_player).sendEvent("PLAY");
      }
      dojo.addClass(this.id+"_jwpc_currentposition","focusActive");
      dojo.removeClass(this.id+"_jwpc_currentposition","jwpc_semantic");
    },
    sliderBlur: function() {
      dijit.byId(this.id+"_jwpc_timeline").set('disabled',false);
      dojo.removeClass(this.id+"_jwpc_currentposition","focusActive");
      if (!dojo.hasClass(this.id+"_jwpc_currentposition","hoverActive"))
      {
        dojo.addClass(this.id+"_jwpc_currentposition","jwpc_semantic");
      }
    },
    seek: function(seekValue) {
      dojo.byId(this.jwpc_player).sendEvent("SEEK", seekValue); 
    },
    sliderStart: function() {
      if (this.jwpc_currentPosition != 0 && (this.jwpc_currentPlayState != "BUFFERING" || this.jwpc_currentPlayState != "PLAYING"))
      {
        dojo.byId(this.id+"_jwpc_Play").focus();
        
        if (this.slider.value == this.valuenow)
        {
          this.playPause();
          this.seek(this.slider.value);
        }
        else
        {
          this.seek(this.slider.value);
        }
      }     
    },
    sliderKeyUp: function(e) {
      var key = e.keyCode;

      if(key == dojo.keys.ENTER || key == dojo.keys.SPACE)
      {  
        this.sliderStart();
      }

      if(key == dojo.keys.LEFT_ARROW || key == dojo.keys.RIGHT_ARROW)
      {
        this.jwpc_arrowSeek = true;
      }
    },
    sliderMouseUp: function() {
      this.sliderStart();
    },
    sliderChange: function(val) {
      this.updateTimer(val);
      this.moveSlider(val);
    },
    moveSlider: function(calculateValue)
    {
      var msSec = Math.floor(calculateValue%60);
      msSec = dojo.string.pad(msSec,2,"0");
      var msMin = Math.floor((calculateValue/60)%60);
      var msHour = Math.floor(calculateValue/(60*60));
      if (msMin > 9 || msHour > 0)
      {
        msMin = dojo.string.pad(msMin,2,"0");
      }
      var msHuman="";
      if (msHour > 0)
      { 
        msHuman = msHour + " hours ";
      }
      if (eval(msMin) > 0)
      {
        msHuman += msMin + " minutes ";
      }
      msHuman += msSec + " seconds";
      this.sliderIncrement = Math.floor(parseFloat(this.duration * (calculateValue)) * 10000)/10000;
      dojo.query("#"+this.id+" .dijitSliderProgressBar").style({"width":this.sliderIncrement+"%"});
      dojo.query("#"+this.id+" .dijitSliderImageHandle").attr("aria-valuenow",msHuman);
      dojo.query("#"+this.id+' input[name="'+this.id+'"]').attr("value",calculateValue);
    },
    addListeners: function(obj) {
        dojo.byId(obj.id).addModelListener("STATE", "playListener");
        dojo.byId(obj.id).addModelListener("TIME", "timeListener");
        dojo.byId(obj.id).addControllerListener("VOLUME", "volumeListener");
        dojo.byId(obj.id).addControllerListener("MUTE", "muteListener");
        dojo.byId(obj.id).addModelListener("STATE", "stateListener");
    },
    
    updateState: function(obj) {
      this.jwpc_currentPlayState = obj.newstate;
      if(this.jwpc_currentPlayState == "COMPLETED")
      {
        this.stop();
      }
      else if(this.jwpc_currentPlayState == "BUFFERING")
      {
        dojo.query('#'+this.id+'_fullscreen #fullscreen').style({
          "display":"none"
        });
        dojo.query('#'+this.id+'_fullscreen #loading').style({
          "display":"block"
        });     
        dojo.style(this.id+'_fullscreen',{
          "left":"0"
        });
        dojo.query('#'+this.id+'_fullscreen div').fadeIn({
          end: 0.75
        }).play();
        dojo.query('#'+this.id+'_fullscreen p').fadeIn().play();  
      } 
      else 
      {
				dojo.query('#'+this.id+'_fullscreen div').fadeOut().play();						
        dojo.query('#'+this.id+'_fullscreen p').fadeOut().play();
      }
    },
    
    updatePlayButtons: function(obj) {
      this.jwpc_currentPlayState = obj.newstate;
      var pb = dojo.byId(this.id+"_jwpc_Play").childNodes[0];
      var pbd = dijit.byId(this.id+"_jwpc_Play");
      if (this.jwpc_currentPlayState == "BUFFERING" || this.jwpc_currentPlayState == "PLAYING")
      {
        dojo.removeClass(pb, "jwIconPlay");
        dojo.addClass(pb, "jwIconPause");
        pbd.set("label","Pause");
      }
      else 
      {
        dojo.removeClass(pb, "jwIconPause");
        dojo.addClass(pb, "jwIconPlay");
        pbd.set("label","Play");
      }
    },    
    updatePosition: function(obj) {
      this.jwpc_currentPosition = Math.floor(obj.position); 
      this.updateTimer(this.jwpc_currentPosition);
      this.sliderPosition(this.jwpc_currentPosition);
      this.accessibilityButtonStateChecker();
    },
    updateTimer: function(curpos)
    {
      var pos = Math.floor(curpos);
      var dur = Math.floor(this.jwpc_duration);
      
      var totSec = Math.floor(dur%60);
      totSec = dojo.string.pad(totSec,2,"0");
      var totMin = Math.floor((dur/60)%60);
      var totHour = Math.floor(dur/(60*60));
      var curSec = Math.floor(pos%60);
      curSec = dojo.string.pad(curSec,2,"0");
      var curMin = Math.floor((pos/60)%60);
      var curHour = Math.floor(pos/(60*60));
      if (totMin > 9 || totHour > 0)
      {
        totMin = dojo.string.pad(totMin,2,"0");
        curMin = dojo.string.pad(curMin,2,"0");
      }

      var prettyCurTime = "";
      var prettyTotTime = "";
      if (totHour > 0)
      { 
        prettyCurTime = curHour + ":";
        prettyTotTime = totHour + ":";
      }
      if (eval(totMin) > 0)
      {
        prettyCurTime += curMin + ":";
        prettyTotTime += totMin + ":";
      }
      prettyCurTime += curSec;
      prettyTotTime += totSec;
   
      dojo.byId(this.id+"_jwpc_timerlabel").innerHTML = '<span class="jwpc_semantic">Elapsed time: </span>'+prettyCurTime+'/'+prettyTotTime;
      dojo.query("#"+this.id+'_jwpc_currentposition div').html(prettyCurTime);
    },
    sliderPosition: function(curpos) {
      this.valuenow = Math.floor(curpos);
      if (this.jwpc_oldPosition < this.valuenow && this.slider.value < curpos)
      {
        this.slider.value = this.valuenow;
        var spSec = Math.floor(this.valuenow%60);
        spSec = dojo.string.pad(spSec,2,"0");
        var spMin = Math.floor((this.valuenow/60)%60);
        var spHour = Math.floor(this.valuenow/(60*60));
        if (spMin > 9 || spHour > 0)
        {
          spMin = dojo.string.pad(spMin,2,"0");
        }
        var spHuman="";
        if (spHour > 0)
        { 
          spHuman = spHour + " hours ";
        }
        if (eval(spMin) > 0)
        {
          spHuman += spMin + " minutes ";
        }
        spHuman += spSec + " seconds";
        dojo.query("#"+this.id+" .dijitSliderImageHandle").attr("aria-valuenow",spHuman);
        dojo.query("#"+this.id+' input[name="'+this.id+'"]').attr("value",this.valuenow);
        this.sliderIncrement = this.sliderIncrement + this.duration;
        dojo.query("#"+this.id+" .dijitSliderProgressBar").style({"width":(Math.round(parseFloat(this.sliderIncrement) * 10000)/10000)+"%"});
      }
      this.jwpc_oldPosition = curpos;
    },   
    updateMuteButton: function(obj) {
      this.jwpc_muteState = obj.state;
      var mutB = dijit.byId(this.id+"_jwpc_Mute");
      var mute  = dojo.byId(this.id+"_jwpc_Mute").childNodes[0];
      if (this.jwpc_muteState)
      {
        mutB.set("label","Un-mute");
        dojo.removeClass(mute,"jwIconMuteOff");
        dojo.addClass(mute,"jwIconMuteOn");
      }
      if (this.jwpc_currentvolume != 0 && !this.jwpc_muteState)
      {
        mutB.set("label","Mute");
        dojo.removeClass(mute,"jwIconMuteOn");
        dojo.addClass(mute,"jwIconMuteOff");
      }

      var uvb = dijit.byId(this.id+"_jwpc_VolumeUp");
      var dvb = dijit.byId(this.id+"_jwpc_VolumeDown");
      
      if (this.jwpc_currentvolume < 100 && !this.jwpc_muteState) 
      {
        uvb.set("label","Increase Volume to "+ eval(this.jwpc_currentvolume + this.jwpc_volumeincrease) +"%");
        dvb.set("label","Decrease Volume to "+ eval(this.jwpc_currentvolume + this.jwpc_volumedecrease) +"%");
      }
      else if (this.jwpc_muteState) 
      {
        var volume = ((this.jwpc_currentvolume + this.jwpc_volumeincrease) >= 100) ? (100) : (this.jwpc_currentvolume + this.jwpc_volumeincrease);
        
        uvb.set("label","Increase Volume to "+ volume +"%");
        dvb.set("label","Volume is muted");       
      }
      else
      {
        uvb.set("label","Volume is 100%");
        dvb.set("label","Decrease Volume to "+ eval(100 + this.jwpc_volumedecrease) +"%");
      }
    },
    updateVolumeButtons: function(obj) {
      this.jwpc_currentvolume = obj.percentage; 
      if(this.jwpc_currentvolume == 0)
      {
        this.jwpc_muteState = true;
      }
      else
      {
        this.jwpc_muteState = false;
      }
      
      var uvb = dijit.byId(this.id+"_jwpc_VolumeUp");
      var dvb = dijit.byId(this.id+"_jwpc_VolumeDown");
      var mutB = dijit.byId(this.id+"_jwpc_Mute");
      var mute  = dojo.byId(this.id+"_jwpc_Mute").childNodes[0];
      
      if (this.jwpc_currentvolume < 100 && !this.jwpc_muteState) 
      {
        uvb.set("label","Increase Volume to "+ eval(this.jwpc_currentvolume + this.jwpc_volumeincrease) +"%");
        dvb.set("label","Decrease Volume to "+ eval(this.jwpc_currentvolume + this.jwpc_volumedecrease) +"%");
        mutB.set("label","Mute");
        dojo.removeClass(mute,"jwIconMuteOn");
        dojo.addClass(mute,"jwIconMuteOff"); 
      }
      else if (this.jwpc_muteState) 
      {
        var volume = ((this.jwpc_currentvolume + this.jwpc_volumeincrease) >= 100) ? (100) : (this.jwpc_currentvolume + this.jwpc_volumeincrease);
        
        uvb.set("label","Increase Volume to "+ volume +"%");
        dvb.set("label","Volume is muted");
        mutB.set("label","Un-mute");
        dojo.removeClass(mute,"jwIconMuteOff");
        dojo.addClass(mute,"jwIconMuteOn"); 
      }
      else
      {
        uvb.set("label","Volume is 100%");
        dvb.set("label","Decrease Volume to "+ eval(100 + this.jwpc_volumedecrease) +"%");
      }
    },
    playPause: function() {
      if (this.jwpc_arrowSeek == true)
      {
        dojo.byId(this.jwpc_player).sendEvent("SEEK", this.slider.value);
        this.jwpc_arrowSeek = false;
      }
      else
      {
        this.slider.value = Math.floor(this.jwpc_currentPosition);
        this.moveSlider(this.jwpc_currentPosition);
        dojo.byId(this.jwpc_player).sendEvent("PLAY");    
      }
    },
    stop: function() {
      dojo.byId(this.jwpc_player).sendEvent("STOP");
      var pb = dojo.byId(this.id+"_jwpc_Play").childNodes[0];
      dojo.removeClass(pb, "jwIconPause");
      dojo.addClass(pb, "jwIconPlay");
      this.updateTimer(0);
      this.jwpc_oldPosition = 0;
      this.sliderIncrement = 0;
      this.slider.value = 0;
      this.jwpc_currentPosition = 0;
      this.jwpc_oldPosition = 0;
      this.slider.value = 0;
      this.moveSlider(0);
    },
    seekBack: function() {
      var calcpos = Math.floor(this.jwpc_currentPosition - this.backSkiptime);
      
      if (calcpos > 0)
      { 
        this.moveSlider(calcpos);
        dojo.byId(this.jwpc_player).sendEvent("SEEK", calcpos);
      }
    },    
    seekForward: function() { 
      var calcpos = Math.floor(this.jwpc_currentPosition + this.forwardSkiptime);
      
      if (calcpos < this.jwpc_duration && this.jwpc_currentPosition != 0)
      {
        this.moveSlider(calcpos);
        dojo.byId(this.jwpc_player).sendEvent("SEEK", calcpos);
      }
    },   
    volume: function(volumeChange)
    {
      var newVolume = volumeChange;
      dojo.byId(this.jwpc_player).sendEvent("VOLUME",newVolume);
    },    
    volumeDown: function() {
      var newVolume = this.jwpc_currentvolume + this.jwpc_volumedecrease;

      if (newVolume <= 0) {
        newVolume = 0;
      }

      dojo.byId(this.jwpc_player).sendEvent("VOLUME",newVolume);
    },
    volumeUp: function() {
      var newVolume = this.jwpc_currentvolume + this.jwpc_volumeincrease;
        
      if (newVolume >= 100) {
        newVolume = 100;
      }

      dojo.byId(this.jwpc_player).sendEvent("VOLUME",newVolume);
    },
    mute: function() 
    {
      dojo.byId(this.jwpc_player).sendEvent("MUTE");
    },
    description: function() {
      if (this.jwpc_audiodescfile)
      {
        var desc = dojo.byId(this.id+"_jwpc_Description").childNodes[0];
        var descB = dijit.byId(this.id+"_jwpc_Description"); 
          
        dojo.byId(this.jwpc_player).toggleAD('true');
        
        if (dojo.byId(this.jwpc_player).adState('') === 'false') 
        {
          dojo.removeClass(desc, "jwIconAdOn");
          dojo.addClass(desc, "jwIconAdOff");
          descB.set("label","Turn Audio Descriptions On");
        }
        else
        {
          dojo.removeClass(desc, "jwIconAdOff");
          dojo.addClass(desc, "jwIconAdOn");
          descB.set("label","Turn Audio Descriptions Off");
        }
      }
      else
      {
        this.descriptionB.setDisabled(true);
      }
    },
    captions: function() {
      if (this.jwpc_captionfile)
      {
        var cap = dojo.byId(this.id+"_jwpc_Captions").childNodes[0];
        var capB = dijit.byId(this.id+"_jwpc_Captions");
        
        dojo.byId(this.jwpc_player).toggleCaptions('true');
        
        if (dojo.byId(this.jwpc_player).captionState('') === 'false')
        {
          dojo.removeClass(cap, "jwIconCcOn");
          dojo.addClass(cap, "jwIconCcOff");
          capB.set("label","Turn Player Captions On");
          this.jwpc_captionstate = "false";
        }
        else
        {
          dojo.removeClass(cap, "jwIconCcOff");
          dojo.addClass(cap, "jwIconCcOn");
          capB.set("label","Turn Player Captions Off");
          this.jwpc_captionstate = "true";
        }
      }
      else
      {
        this.captionsB.setDisabled(true);
      }
    },
		resizeVideo:function() {
		  this.maxHeight = dojo.window.getBox().h - 58;
      this.maxWidth = dojo.window.getBox().w - 48;
      this.vidHeight = this.jwpc_videoheight;
      this.vidWidth = this.jwpc_videowidth;
      if(this.vidWidth/this.maxWidth > this.vidHeight/this.maxHeight)
      {
        this.newWidth  = this.maxWidth;
        this.newHeight = this.newWidth/this.vidWidth*this.vidHeight;
      }
      else
      {
        this.newHeight = this.maxHeight;
        this.newWidth  = this.newHeight/this.vidHeight*this.vidWidth;
      } 
      /* calculate horizontal position in container */
      this.ecB = dijit.byId(this.id+"_jwpc_Enlarge");
      this.eb  = dojo.byId(this.id+"_jwpc_Enlarge").childNodes[0];
      this.plw = dojo.byId(this.id+"_jwpc_playerwrapper");
      this.plc = dojo.byId(this.id+"_jwpc_playercontainer");	

      dojo.style(this.plw, {
        width:this.newWidth + "px",
        height:this.newHeight + "px"
      });
			
      var viewport = dojo.window.getBox();
			dojo.style("jwpc-underlay-container", {
			  display:"block",
			  width: viewport.w + "px",
        height: viewport.h + "px",
        top: viewport.t + "px",
        left: viewport.l + "px"
			});		      
			
			dojo.query("#jwpc-shim").style({
				position:"absolute",
				top:((dojo.window.getBox().h/2) - ((this.newHeight / 2) - 8)) + "px"
      });	
			
      dojo.style(this.plc, {
        width:this.newWidth + "px",
         top: Math.floor( dojo.position("jwpc-shim", true).y - dojo.position(this.plc, true).y + 20 ) + "px",
         left: Math.floor( dojo.window.getBox().w/2 - (this.newWidth / 2) - dojo.position(this.id, true).x - 5 ) + "px",
       zIndex:999
     });

      dojo.query('#'+this.id+'_fullscreen').style({
        fontSize: "1.8em",
        height: this.newHeight-24 + "px"
      });
		},
    enlarge: function() 
    {
      if (dojo.hasClass(this.id+"_jwpc_Enlarge","active") === false && (dojox.embed.Flash.available >= this.jwpc_flashVersion)) { 		
				
				if (dojo.isIE <= 7) {
					dojo.style(this.id,{
		        position: "absolute",
						zIndex:9999
		      });
					dojo.query("#"+this.id+"_ie-shim").style({
		        display: "block",
						height:this.jwpc_videoheight+"px",
						width:this.jwpc_videowidth+"px"
		      });
				}
				
				this.resizeVideo();

				dojo.query(this.jwpc_focusable).forEach(function(node,index,array) {
					jwpc_global_var.tabindex[index] = node.getAttribute("tabindex");
					node.setAttribute("tabindex",-1);
				});
				
				dojo.query(".jwpc_timer, .dijitSliderImageHandle, .dijitToolbar").attr("tabindex", -1);

				dojo.query(".jwpc_timer, .dijitSliderImageHandle, .dijitToolbar",dojo.byId(this.id)).attr("tabindex", 0);
				
        dojo.removeClass(this.eb, "jwIconEnlarge");
        dojo.addClass(this.eb, "jwIconUnEnlarge");
        this.ecB.set("label","Contract Movie");

        dojo.addClass(this.id+"_jwpc_Enlarge","active");

      }
      else if (dojo.hasClass(this.id+"_jwpc_Enlarge","active") === true && dojox.embed.Flash.available >= this.jwpc_flashVersion)
      {
				dojo.query(this.jwpc_focusable).forEach(function(node,index,array) {
			 		if(jwpc_global_var.tabindex[index] !== null) {
						node.setAttribute("tabindex",jwpc_global_var.tabindex[index]);
					}
					else {
						node.removeAttribute("tabindex");
					}
				});
	
				dojo.query(".jwpc_timer, .dijitSliderImageHandle, .dijitToolbar").attr("tabindex", 0);
	
				this.tabindex = [];
	
				if (dojo.isIE <= 7) {
					dojo.style(this.id,{
		        position: "relative",
						zIndex:""
		      });
					dojo.query("#"+this.id+"_ie-shim").style({
		        display: "none"
		      });
				}
	
 				dojo.style("jwpc-underlay-container", {
				  display:"none"
				});
				
        dojo.style(this.plc, {width:this.jwpc_videowidth + "px",left:0,top:0,zIndex:997});
        dojo.style(this.plw, {width:this.jwpc_videowidth + "px",height:this.jwpc_videoheight + "px"});

        dojo.removeClass(this.eb, "jwIconUnEnlarge");
        dojo.addClass(this.eb, "jwIconEnlarge");
        this.ecB.set("label","Enlarge Movie"); 
        
        dojo.query('#'+this.id+'_fullscreen').style({
          "fontSize": "1.1em",
          "height": (this.jwpc_videoheight - 24) + "px"
        });
        
        dojo.removeClass(this.id+"_jwpc_Enlarge","active");
				
      } 
    }
  }
);

playListener = function(obj) 
{
  for(var i = 0; i < jwpc_global_obj.length; i++) {
    
    var ins = jwpc_global_obj[i];
    
    if ( obj.id.replace(/_movie/ , "") == ins.id ) {
      
      ins.updatePlayButtons(obj);
      
    }
  }
}

timeListener = function(obj) 
{ 
  for(var i = 0; i < jwpc_global_obj.length; i++) {
    
    var ins = jwpc_global_obj[i];

    if ( obj.id.replace(/_movie/ , "") == ins.id ) {
      
      ins.updatePosition(obj);
      
    }
  }
}

volumeListener = function(obj) 
{ 
  for(var i = 0; i < jwpc_global_obj.length; i++) {
    
    var ins = jwpc_global_obj[i];

    if ( obj.id.replace(/_movie/ , "") == ins.id ) {
      
      ins.updateVolumeButtons(obj);
      
    }
  }
}

muteListener = function(obj) 
{ 
  for(var i = 0; i < jwpc_global_obj.length; i++) {
    
    var ins = jwpc_global_obj[i];

    if ( obj.id.replace(/_movie/ , "") == ins.id ) {
      
      ins.updateMuteButton(obj);
      
    }
  }
}

stateListener = function(obj) 
{ 
  for(var i = 0; i < jwpc_global_obj.length; i++) {
    
    var ins = jwpc_global_obj[i];

    if ( obj.id.replace(/_movie/ , "") == ins.id ) {
      
      ins.updateState(obj);
      
    }
  }
}

playerReady = function(obj) 
{      
  for(var i = 0; i < jwpc_global_obj.length; i++) {
    
    var ins = jwpc_global_obj[i];
    
    ins.addListeners(obj);
    ins.updateTimer(ins.jwpc_currentPosition);
  
  }
}